//
//  ViewController.swift
//  CalculatorPlusDemo
//
//  Created by Kevin McNeish on 12/15/14.
//  Copyright (c) 2014 Oak Leaf Enterprises, Inc. All rights reserved.
//

import UIKit

import UIKit

class ViewController: UIViewController {
    
    @IBOutlet weak var lblTotal: UILabel!
    @IBOutlet var operationHighlightImages: [UIImageView]!
    
    var calculator = Calculator()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    // MARK: - Calculator user interface
    @IBAction func highlightOperation(sender: UIButton) {
        
        for imageView in self.operationHighlightImages {
            
            imageView.alpha = (imageView.tag == sender.tag) ? 1 : 0
        }
    }
    
    @IBAction func numberTouched(sender: UIButton) {
        
        self.hideOperationHighlight()
        
        var numberString = ""
        var tagNumber = sender.tag
        numberString = (tagNumber == -1) ? "." : "\(tagNumber)"
        self.hideOperationHighlight()
        
        self.lblTotal.text =
            self.calculator.processNumber(numberString)
    }
    
    @IBAction func operationTouched(sender: UIButton) {
        
        let operation = Operation(rawValue: sender.tag)
        
        if operation == Operation.Clear {
            self.hideOperationHighlight()
        }
        
        self.lblTotal.text =
            self.calculator.performOperation(operation!)
    }
    
    func hideOperationHighlight() {
        for imageView in self.operationHighlightImages {
            imageView.alpha = 0
        }
    }
}

