//
//  Email.swift
//  HideKeyboardDemo
//
//  Created by Kevin McNeish on 5/29/15.
//  Copyright (c) 2015 Oak Leaf Enterprises, Inc. All rights reserved.
//

import Foundation

public class Email {
    
    public static var stricterFilter = true // Discussion http://blog.logichigh.com/2010/09/02/validating-an-e-mail-address/
    
    // Test if the specified email address is valid
    public static func isEmailValid(email: String) -> Bool {
        
        var filterString: String
        
        if Email.stricterFilter {
            // Strict filter string
            filterString = "[A-Z0-9a-z._%+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,4}"
        }
        else {
            // lax filter string
            filterString = ".+@.+\\.[A-Za-z]{2}[A-Za-z]*"
        }
        
        let emailTest = NSPredicate(format: "SELF MATCHES %@", filterString)
		
		return emailTest.evaluateWithObject(email)
    }
}
