//
//  MasterViewController.swift
//  IndexedTableViewDemo
//
//  Created by Kevin McNeish on 2/14/15.
//  Copyright (c) 2015 Oak Leaf Enterprises, Inc. All rights reserved.
//

import UIKit

class MasterViewController: UITableViewController {

    var customer = Customer()
	var customerList = Array<CustomerEntity>()

    override func awakeFromNib() {
        super.awakeFromNib()
    }

    override func viewDidLoad() {
        super.viewDidLoad()
		
        self.customerList = customer.getAllEntities()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


    // MARK: - Segues

    // MARK: - Table View

    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        return 1
    }

    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return self.customerList.count
    }

    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCellWithIdentifier("Cell", forIndexPath: indexPath) as! UITableViewCell

        let customerEntity = self.customerList[indexPath.row]
        cell.textLabel!.text = customerEntity.fullName
        return cell
    }

    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
		if segue.identifier == "DetailSegue" {
        
       		let indexPath = self.tableView.indexPathForSelectedRow()
			let dvc = segue.destinationViewController as! DetailViewController
        	dvc.customerEntity = self.customerList[indexPath!.row]
        }
    }
}

