//
//  Draw2DPreview.swift
//  TicTacToe
//
//  Created by Kevin McNeish on 5/4/15.
//  Copyright (c) 2015 Oak Leaf Enterprises, Inc. All rights reserved.
//

import UIKit
import TicTacToeFramework

class Draw2DPreview: UIView {
    
    var themeEntity: ThemeEntity!

    /*
    // Only override drawRect: if you perform custom drawing.
    // An empty implementation adversely affects performance during animation.
    override func drawRect(rect: CGRect) {
        // Drawing code
    }
    */
    
    // Only override drawRect: if you perform custom drawing.
    // An empty implementation adversely affects performance during animation.
    override func drawRect(rect: CGRect) {
        // Drawing code
        
        var x = self.frame.origin.x * -1
        var y = self.frame.origin.y * -1
    	let leftMargin = CGFloat(13)
        let topMargin = CGFloat(5)
        
        var context = UIGraphicsGetCurrentContext()
        CGContextSetLineWidth(context, 2)
        
        CGContextSetStrokeColorWithColor(context,
            self.themeEntity.tintBoard.CGColor)
        
        // |
        CGContextMoveToPoint(context, x+30+leftMargin, y+topMargin)
        CGContextAddLineToPoint(context, x+30+leftMargin, y+89+topMargin)
        CGContextStrokePath(context)
        
        // |  |
        CGContextMoveToPoint(context, x+60+leftMargin, y)
        CGContextAddLineToPoint(context, x+60+leftMargin, y+89+topMargin)
        CGContextStrokePath(context)

        // -
        CGContextMoveToPoint(context, x+leftMargin, y+30+topMargin)
        CGContextAddLineToPoint(context, x+89+leftMargin, y+30+topMargin)
        CGContextStrokePath(context)

        // -
        // -
        CGContextMoveToPoint(context, x+leftMargin, y+60+topMargin)
        CGContextAddLineToPoint(context, x+leftMargin+89, y+60+topMargin)
        CGContextStrokePath(context)
        
        // Draw the X's
        context = UIGraphicsGetCurrentContext()
        CGContextSetLineWidth(context, 4)
        CGContextSetStrokeColorWithColor(context,
            self.themeEntity.tintX.CGColor)
        
        // X position a
        CGContextMoveToPoint(context, x+5+leftMargin, y+5+topMargin)
        CGContextAddLineToPoint(context, x+25+leftMargin, y+25+topMargin)
        CGContextStrokePath(context)
        
        CGContextMoveToPoint(context, x+5+leftMargin, y+25+topMargin)
        CGContextAddLineToPoint(context, x+25+leftMargin, y+5+topMargin)
        CGContextStrokePath(context)
        
        // X position c
        CGContextMoveToPoint(context, x+65+leftMargin, y+5+topMargin)
        CGContextAddLineToPoint(context, x+84+leftMargin, y+25+topMargin)
        CGContextStrokePath(context)
        
        CGContextMoveToPoint(context, x+65+leftMargin, y+25+topMargin)
        CGContextAddLineToPoint(context, x+84+leftMargin, y+5+topMargin)
        CGContextStrokePath(context)
        
        // X position e
        CGContextMoveToPoint(context, x+35+leftMargin, y+35+topMargin)
        CGContextAddLineToPoint(context, x+55+leftMargin, y+55+topMargin)
        CGContextStrokePath(context)
        
        CGContextMoveToPoint(context, x+35+leftMargin, y+55+topMargin)
        CGContextAddLineToPoint(context, x+55+leftMargin, y+35+topMargin)
        CGContextStrokePath(context)
        
        // X position g
        CGContextMoveToPoint(context, x+5+leftMargin, y+65+topMargin)
        CGContextAddLineToPoint(context, x+25+leftMargin, y+84+topMargin)
        CGContextStrokePath(context)
        
        CGContextMoveToPoint(context, x+5+leftMargin, y+84+topMargin)
        CGContextAddLineToPoint(context, x+25+leftMargin, y+65+topMargin)
        CGContextStrokePath(context)
        
        // X position i
        CGContextMoveToPoint(context, x+65+leftMargin, y+65+topMargin)
        CGContextAddLineToPoint(context, x+84+leftMargin, y+84+topMargin)
        CGContextStrokePath(context)
        
        CGContextMoveToPoint(context, x+65+leftMargin, y+84+topMargin)
        CGContextAddLineToPoint(context, x+84+leftMargin, y+65+topMargin)
        CGContextStrokePath(context)
        
        // Draw the O's
        CGContextSetStrokeColorWithColor(context,
            self.themeEntity.tintO.CGColor)

        var rectangle = CGRectMake(35, 5, 20, 20)
        CGContextAddEllipseInRect(context, rectangle)
        CGContextStrokePath(context)
        
        rectangle = CGRectMake(5, 35, 20, 20)
        CGContextAddEllipseInRect(context, rectangle)
        CGContextStrokePath(context)
        
        rectangle = CGRectMake(65, 35, 20, 20)
        CGContextAddEllipseInRect(context, rectangle)
        CGContextStrokePath(context)
        
        rectangle = CGRectMake(35, 65, 20, 20)
        CGContextAddEllipseInRect(context, rectangle)
        CGContextStrokePath(context)
        
    }

}
