//
//  Member.swift
//  TicTacToe
//
//  Created by Kevin McNeish on 4/11/15.
//  Copyright (c) 2015 Oak Leaf Enterprises, Inc. All rights reserved.
//

import Foundation

private let singletonInstance = Member()

public class Member<T: MemberEntity>: ABusinessObject<T> {
    
    
    var memberEntity: MemberEntity!
    
    var memberID: String {
        get {
            return self.memberEntity.memberID
        }
        set {
            self.memberEntity.memberID = newValue
        }
    }
    
    var name: String {
        get {
            return self.memberEntity.name
        }
        set {
            self.memberEntity.name = newValue
        }
    }
    
    var totalWinsEasy: Int {
        get {
            return self.memberEntity.totalWinsEasy.integerValue
        }
        set {
            self.memberEntity.totalWinsEasy = newValue
        }
    }
    
    var totalWinsMedium: Int {
        get {
            return self.memberEntity.totalWinsMedium.integerValue
        }
        set {
            self.memberEntity.totalWinsMedium = newValue
        }
    }
    
    var totalWinsDifficult: Int {
        get {
            return self.memberEntity.totalWinsDifficult.integerValue
        }
        set {
            self.memberEntity.totalWinsDifficult = newValue
        }
    }
    
    var totalTiesEasy: Int {
        get {
            return self.memberEntity.totalTiesEasy.integerValue
        }
        set {
            self.memberEntity.totalTiesEasy = newValue
        }
    }
    
    var totalTiesMedium: Int {
        get {
            return self.memberEntity.totalTiesMedium.integerValue
        }
        set {
            self.memberEntity.totalTiesMedium = newValue
        }
    }
    
    var totalTiesDifficult: Int {
        get {
            return self.memberEntity.totalTiesDifficult.integerValue
        }
        set {
            self.memberEntity.totalTiesDifficult = newValue
        }
    }
    
    var totalLossesEasy: Int {
        get {
            return self.memberEntity.totalLossesEasy.integerValue
        }
        set {
            self.memberEntity.totalLossesEasy = newValue
        }
    }
    
    var totalLossesMedium: Int {
        get {
            return self.memberEntity.totalLossesMedium.integerValue
        }
        set {
            self.memberEntity.totalLossesMedium = newValue
        }
    }
    
    var totalLossesDifficult: Int {
        get {
            return self.memberEntity.totalLossesDifficult.integerValue
        }
        set {
            self.memberEntity.totalLossesDifficult = newValue
        }
    }
    
    var winningStreakEasy: Int {
        get {
            return self.memberEntity.winningStreakEasy.integerValue
        }
        set {
            self.memberEntity.winningStreakEasy = newValue
        }
    }
    
    var winningStreakMedium: Int {
        get {
            return self.memberEntity.winningStreakMedium.integerValue
        }
        set {
            self.memberEntity.winningStreakMedium = newValue
        }
    }
    
    var winningStreakDifficult: Int {
        get {
            return self.memberEntity.winningStreakDifficult.integerValue
        }
        set {
            self.memberEntity.winningStreakDifficult = newValue
        }
    }
    
    public class var sharedInstance: Member<MemberEntity> {
        return singletonInstance
    }
    
    override init() {
        super.init()
        
        var memberList = self.getAllEntities()
        if memberList.count > 0 {
            self.memberEntity = memberList[0]
        }
        else {
            self.memberEntity = self.createEntity()
            self.memberEntity.memberID = NSUUID().UUIDString
            self.memberEntity.name = NSLocalizedString("You", comment: "First person reference to the player")
            self.saveEntities()
        }
    }
    
    public func resetWinningStreaks() {
        self.winningStreakEasy = 0
        self.winningStreakMedium = 0
        self.winningStreakDifficult = 0
        self.saveEntities()
    }
}