//
//  Move.swift
//  TicTacToe
//
//  Created by Kevin McNeish on 5/25/15.
//  Copyright (c) 2015 Oak Leaf Enterprises, Inc. All rights reserved.
//

import Foundation

public struct Move: Equatable {
    
    public var position: Position
    public var mark: String
    
    public init(position: Position, mark: String) {
        self.position = position
        self.mark = mark
    }
}

public func ==(lhs: Move, rhs: Move) -> Bool {
    
    // To be equal, the position and mark must match OR
    // The position matches and the mark is "XO" representing
    // either X or O
    if lhs.position == rhs.position {
        if lhs.mark == rhs.mark || rhs.mark == "XO" {
            return true
        }
    }
    return false
}