//
//  ThemeBundleEntity.swift
//  TicTacToe
//
//  Created by Kevin McNeish on 4/29/15.
//  Copyright (c) 2015 Oak Leaf Enterprises, Inc. All rights reserved.
//

import Foundation
import CoreData
import StoreKit

public class ThemeBundleEntity: NSManagedObject, Equatable, Comparable {

    @NSManaged public var themeBundleID: String
    @NSManaged public var themeBundleName: String
    @NSManaged public var purchased: NSNumber
    @NSManaged public var displayOrder: NSNumber
    @NSManaged public var themeRed: NSNumber
    @NSManaged public var themeGreen: NSNumber
    @NSManaged public var themeBlue: NSNumber
    public var product: SKProduct?
}

public func ==(lhs: ThemeBundleEntity, rhs: ThemeBundleEntity) -> Bool {
    return lhs.themeBundleID == rhs.themeBundleID}

public func <(lhs: ThemeBundleEntity, rhs: ThemeBundleEntity) -> Bool {
    return lhs.displayOrder.integerValue < rhs.displayOrder.integerValue
}

public func byDisplayOrder(order1: Int, order2: Int) -> Bool {
    return order1 > order2
}