//
//  ThemeEntity.swift
//  TicTacToe
//
//  Created by Kevin McNeish on 4/18/15.
//  Copyright (c) 2015 Oak Leaf Enterprises, Inc. All rights reserved.
//

import Foundation
import CoreData

public class ThemeEntity: NSManagedObject {

    @NSManaged public var themeBundleID: String
    @NSManaged public var themeID: NSNumber
    @NSManaged public var name: String
    @NSManaged public var thumbNailName: String
    @NSManaged private var lightContent: NSNumber
    @NSManaged private var displayOrder: NSNumber
    @NSManaged private var themeORed: NSNumber
    @NSManaged private var themeOGreen: NSNumber
    @NSManaged private var themeOBlue: NSNumber
    @NSManaged private var themeXRed: NSNumber
    @NSManaged private var themeXBlue: NSNumber
	@NSManaged private var themeXGreen: NSNumber
    @NSManaged private var themeBoardBlue: NSNumber
    @NSManaged private var themeBoardRed: NSNumber
    @NSManaged private var themeBoardGreen: NSNumber
    @NSManaged private var isFree: NSNumber
    @NSManaged private var useOnAppleWatch: NSNumber
    
    public var useOnAppleWatchSetting: Bool {
        
        get {
            return self.useOnAppleWatch.boolValue
        }
        set {
            self.useOnAppleWatch = newValue
        }
    }
    
    public var lightContentSetting: Bool {
        
        get {
            return self.lightContent.boolValue
        }
    }
    
    var displayOrderSetting: Double {
        
        get {
            return self.displayOrder.doubleValue
        }
    }
    
    var isFreeSetting: Bool {
        return self.isFree.boolValue
    }
    
    public var tintX: UIColor {
       return UIColor(red: CGFloat(self.themeXRed)/255.0, green: CGFloat(self.themeXGreen)/255.0, blue: CGFloat(self.themeXBlue)/255.0, alpha: 1.0)
    }
    
    public var tintO: UIColor {
        return UIColor(red: CGFloat(self.themeORed)/255.0,
            green: CGFloat(self.themeOGreen)/250.0,
            blue: CGFloat(self.themeOBlue)/255.0,
            alpha: 1.0)
    }
    
    public var tintBoard: UIColor {
        return UIColor(red: CGFloat(self.themeBoardRed)/255.0,
            green: CGFloat(self.themeBoardGreen)/250.0,
            blue: CGFloat(self.themeBoardBlue)/255.0,
            alpha: 1.0)
    }
    
    convenience init() {
        self.init()
    }

}
