//
//  DeliveriesViewController.swift
//  iDeliverMobileCD
//
//  Created by Kevin McNeish on 12/27/14.
//  Copyright (c) 2014 Oak Leaf Enterprises, Inc. All rights reserved.
//

import UIKit

class DeliveriesViewController: UITableViewController {
    
    var shipment = Shipment()
    var shipmentList = Array<ShipmentEntity>()

    override func viewDidLoad() {
        super.viewDidLoad()

        self.shipmentList = self.shipment.getAllEntities()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Table view data source

    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        // Return the number of sections.
        return 1
    }

    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // Return the number of rows in the section.
        return shipmentList.count
    }

    
    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCellWithIdentifier("NameAddress", forIndexPath: indexPath) as! UITableViewCell

        // Configure the cell...
        var shipmentEntity = self.shipmentList[indexPath.row]
        
        cell.textLabel?.text = shipmentEntity.name
        cell.detailTextLabel?.text =
        	shipmentEntity.address + ", " +
        	shipmentEntity.city + ", " +
        	shipmentEntity.region + " " +
        	shipmentEntity.postalCode

        return cell
    }
    
    override func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
        self.performSegueWithIdentifier("ShipmentSegue", sender: nil)
    }
    
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        if segue.identifier == "ShipmentSegue" {
            
            // Get the destination view controller
            var tvc = segue.destinationViewController as! ShipmentViewController
            
            // Get the currently selected row
            var indexPath = self.tableView.indexPathForSelectedRow()
            
            // Save the ShipmentEntity for this row 
            // on the ShipmentViewController
            tvc.shipmentEntity =
                self.shipmentList[indexPath!.row]
            
            // Save the Shipment business controller
            // on the ShipmentViewController
            tvc.shipment = self.shipment
        }
    }
}
